kernel: subroutine

	;== line 1 - load first half of playfield ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	sta GRP0			;3
	stx COLUP0			;3

	ldy section_counter	;3
	lda $1ff9			;4	bamf!

	.ds 21				;sta PF0			;3	$1ff9 contained a 0, hurray!
						;sta PF1			;3
						;sta PF2			;3
						;lda (pf0ptr),y		;5
						;sta pf0buf			;3
						;lda (pf1ptr),y		;5
						;sta pf1buf			;3
						;lda (pf2ptr),y		;5
						;sta pf2buf			;3
						;ldy $1ff8			;4	bamf!
	;back on 50

	;draw sprites....
	;$1ff8 contained a 3
	lax (cl0ptr),y		;5
	lda (sp1ptr),y		;5
	sta GRP1			;3
	lda (sp0ptr),y		;5 = 68

	nop					;2
	sta HMOVE			;3 = 73
	nop 0				;3 = 76


	;== line 2 - load second half of playfield ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	sta GRP0			;3
	stx COLUP0			;3

	ldy section_counter	;3
	lda $1ff9			;3	bamf!
	.ds 15				;lda (pf3ptr),y		;5
						;sta pf3buf			;3
						;lda (pf4ptr),y		;5
						;sta pf4buf			;3
						;lda (pf5ptr),y		;5
						;sta pf5buf			;3
						;lda $1ff8			;3	bamf!
	;return on cycle 39

	tya
	lsr
	lsr
	adc #$b4
	sta COLUPF

	;draw sprites....
	ldy #2				;2
	lax (cl0ptr),y		;5
	lda (sp1ptr),y		;5
	sta GRP1			;3
	lda (sp0ptr),y		;5 = 59

	sta WSYNC


	;== line 3 - draw playfield ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	;update PF by 22.2, 28, 38.2, 49.1, 54.2, 65.1
	;second half must be after 28, 38.2, 49.1

	sta GRP0			;3
	stx COLUP0			;3

	lda pf0buf			;3
	sta PF0				;3
	lda pf1buf			;3
	sta PF1				;3
	lda pf2buf			;3
	sta PF2				;3 = 24

	dey					;2
	lax (cl0ptr),y		;5
	lda (sp1ptr),y		;5
	sta GRP1			;3 = 39

	lda pf3buf			;3
	sta PF0				;3 = 45
	lda pf4buf			;3
	sta PF1				;3 = 51
	lda pf5buf			;3
	sta PF2				;3 = 57
	
	lda (sp0ptr),y		;5 = 62

	dey					;2
	sec					;2
	sty.w PF0			;4
	sty PF1				;3
	sta GRP0			;3 = 76


	;== line 4 - manage player sprite ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	stx COLUP0			;3
	lax (cl0ptr),y		;5	(y is 0 here)
	txs					;2
	sty PF2				;3 = 13

	lda (sp1ptr),y		;5
	sta GRP1			;3
	lax (sp0ptr),y		;5 = 26

	lda section_counter		;3			;<----- change this to dcp-style uber code
	sbc pl_section			;3
	adc pl_span				;3
	bcs .set_player			;2/3
		dec $ff				;5
		lda #<blank			;2
		bcc .done_player	;3
.set_player:
	tay						;2
	lda x6_table,y			;4
	adc pl_lsb				;3
.done_player:
	sta sp0ptr				;3
	sta cl0ptr				;3 = 53

	ldy sprite_list_index		;3
	lda sprite_list_span,y		;4
	sta REFP1					;3
	and #%00000111				;2
	sec							;2
	isb sprite_list_section,y	;7 = 74		<----- look what I did!



	;== line 5 - manage other sprites ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	stx GRP0					;3 = 1
	tsx							;2
	stx COLUP0					;3

	bcs .set_sprite				;2/4
		;cc means there's no sprite in the next section,
		;so we don't have to set up the pointer or anything -
		;instead, we'll do horizontal positioning here
		;-- starting on cycle 8 --

		lax sprite_list_x,y		;4
		cmp #91					;2
		bcs .right_side			;2/3

		;on cycle 16 here
.left_position_loop:
			sbc #15						;2
			bcs .left_position_loop		;2/3

	;max 6 loops = cycle 45
	sta RESP1				;3	23 <= ? <= 48

	lda #<blank				;2
	sta sp1ptr				;3
	sta sp1ptr+1			;3 <= 56
			;the double store here can be removed by having a 256-byte page
			;full of 0s - then you'd just store the upper byte...
			;...but that wouldn't elimate the need for every page with player
			;graphics to have a blank section, since the upper byte of
			;of the player pointer has to remain constant

	lda hmove_table,x		;4
	sta HMP1				;3 <= 65

	ldy #5					;2
	lax (sp0ptr),y			;5 <= 72
	sta WSYNC


	;== line 6(l) - draw playfield again ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	stx COLUP0				;3
	jmp .finish_line_6ns	;3 = 6



	;== line 5(r) - right side sprite positioning ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
.right_side:
	;on cycle 17

	ldy #<blank				;2
	sty sp1ptr				;3
	sty sp1ptr+1			;3 = 25

	ldy hmove_table-91,x	;4
	sty.w HMP1				;4 = 33

	ldy #5					;2
	lda (cl0ptr),y			;5
	tay						;2
	txa						;2
	sbc #91					;2 = 46

.right_position_loop:
		sbc #15						;2
		bcs .right_position_loop	;2/3

	;min 1 loop = cycle 50
	sta RESP1				;3	53 <= ? <= 73
	sta WSYNC


	;== line 6(r) - draw playfield again ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	sty.w COLUP0		;4
	ldy #5				;2

.finish_line_6ns:
	;6 here
	lda (sp0ptr),y		;5
	sta GRP0			;3 = 14

	lda pf0buf			;3
	sta PF0				;3 = 20
	lda pf1buf			;3
	sta PF1				;3 = 26
	lda pf2buf			;3
	sta PF2				;3 = 32

	dey					;2
	lax (cl0ptr),y		;5

	lda pf3buf			;3
	sta PF0				;3 = 45
	lda pf4buf			;3
	sta PF1				;3 = 51
	lda pf5buf			;3
	sta PF2				;3 = 57
	
	lda (sp0ptr),y		;5 = 62
	nop					;2
	nop					;2

	dec section_counter	;5
	bmi .end			;2
	jmp kernel			;3 = 76




	;== line 5(s) - set up sprite stuff ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
.set_sprite:
	;starting on cycle 10

	tax						;2 = 12
	lda x6_table,x			;4			the first table entry (for x=0) is -1, so
	adc sprite_list_lsb,y	;4			it'll set c in that case
	sta sp1ptr				;3 = 23

	lda #128				;2

	bcs .last_section		;2/3
		sta HMP1			;3			this only needs to be done on the /first/ section
		bne .skip_inc		;3
.last_section:
	inc sprite_list_index	;5
.skip_inc:
	;on cycle 33 here

	ldx sprite_list_type,y	;4 = 37
	lda sprite_data_msb,x	;4
	sta sp1ptr+1			;3
	lda sprite_data_colu,x	;4
	sta COLUP1				;3
	lda sprite_data_nusiz,x	;4
	sta NUSIZ1				;3 = 58

	ldy #5					;2
	lax (cl0ptr),y			;5
	lda (sp1ptr),y			;5
	sta GRP1				;3
	lda (sp0ptr),y			;5 = 78, oops...


	;== line 6(s) - draw playfield again ==
	;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	sta GRP0			;3 = 5
	stx COLUP0			;3

	lda pf0buf			;3
	sta PF0				;3
	lda pf1buf			;3
	sta PF1				;3
	lda pf2buf			;3
	sta PF2				;3 = 26

	dey					;2
	lax (cl0ptr),y		;5

	lda pf3buf			;3
	sta PF0				;3 = 39
	lda pf4buf			;3
	sta PF1				;3 = 45
	lda pf5buf			;3
	sta PF2				;3 = 51
	
	lda (sp1ptr),y		;5
	sta GRP1			;3
	lda (sp0ptr),y		;5 = 64

	nop					;2
	dec section_counter	;5
	bmi .end			;2
	jmp kernel			;3 = 76

.end:
	jmp overscan





x6_table:
	;multiplication by 12 table (all values -1)
	.byte -1
	.byte 5
	.byte 11
	.byte 17
	.byte 23	
	.byte 29
	.byte 35

hmove_table:
	;values to put in HMP1 for x = 0 to 90
	.byte $70

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80

	.byte $60
	.byte $50
	.byte $40
	.byte $30
	.byte $20
	.byte $10
	.byte $00
	.byte $f0
	.byte $e0
	.byte $d0
	.byte $c0
	.byte $b0
	.byte $a0
	.byte $90
	.byte $80