	processor 6502
	include "vcs.h"
	include "macro.h"

	seg.u vars
	org $80

pf0ptr				.word
pf1ptr				.word
pf2ptr				.word
pf3ptr				.word
pf4ptr				.word
pf5ptr				.word

pf0buf				.byte
pf1buf				.byte
pf2buf				.byte
pf3buf				.byte
pf4buf				.byte
pf5buf				.byte

cl0ptr				.word
sp0ptr				.word
pl_msb equ *-1

sp1ptr				.word

pl_section			.byte
pl_span				.byte
pl_lsb				.byte

sprite_list_index	.byte
sprite_list_type	.ds 4
sprite_list_x		.ds 4
sprite_list_span	.ds 4
sprite_list_lsb		.ds 4
sprite_list_section	.ds 4		;should go last so sprite_list_section,5 is never drawn

trash_byte			.byte

screen_y			.byte

section_counter		.byte
stack_save			.byte

	echo $100 - *
	echo "bytes left!"



	seg main
	org $0000
	rorg $f000

	include "kernel.asm"

	align 256
smiley:
	.byte 0
	.byte %00111100
	.byte %01000010
	.byte %10000001
	.byte %10011001
	.byte %10100101
	.byte %10100001
	.byte %10000001
	.byte %11100101
	.byte %10000101
	.byte %10000001
	.byte %01000010
	.byte %00111100
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0


	rend
	org $02f2
	rorg $f2f2
blank:
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000
	.byte %00000000

	align 256
smiley_colors:
	.byte 0
	.byte $f4
	.byte $e4
	.byte $d4
	.byte $c4
	.byte $b4
	.byte $a4
	.byte $94
	.byte $84
	.byte $74
	.byte $64
	.byte $54
	.byte $44


sprite_data_msb:
	.byte >smiley
	.byte >smiley
	.byte >smiley
	.byte >smiley

sprite_data_colu:
	.byte $00
	.byte $44
	.byte $86
	.byte $c8

sprite_data_nusiz:
	.byte %000
	.byte %011
	.byte %101
	.byte %000


pf_table:
	.byte <PFData_0a
	.byte >PFData_0a
	.byte <PFData_1a
	.byte >PFData_1a
	.byte <PFData_2a
	.byte >PFData_2a
	.byte <PFData_0b
	.byte >PFData_0b
	.byte <PFData_1b
	.byte >PFData_1b
	.byte <PFData_2b
	.byte >PFData_2b


main:
	CLEAN_START

	lda #$48
	sta COLUBK

	lda #<smiley
	sta pl_lsb
	sta sprite_list_lsb+0
	sta sprite_list_lsb+1
	sta sprite_list_lsb+2
	sta sprite_list_lsb+3

	lda #>smiley
	sta pl_msb

	lda #>smiley+1
	sta cl0ptr+1

	lda #0
	sta sprite_list_type+0
	lda #1
	sta sprite_list_type+1
	lda #2
	sta sprite_list_type+2
	lda #3
	sta sprite_list_type+3

	lda #5
	sta pl_section

	lda #3
	sta pl_span

	lda #2
	sta sprite_list_span+0
	lda #8+2
	sta sprite_list_span+1
	sta sprite_list_span+2
	lda #2
	sta sprite_list_span+3

	lda #15
	sta sprite_list_x+0
	lda #28
	sta sprite_list_x+1
	lda #150
	sta sprite_list_x+2
	lda #100
	sta sprite_list_x+3

	lda #0
	sta screen_y

	lda #1
	sta VDELP1

frame_start: subroutine
	;*******************
	;* vsync - 3 lines *
	;*******************
	VERTICAL_SYNC

	;*********************
	;* vblank - 36 lines *
	;*********************
	lda #38
	sta TIM64T				;38*64 = 32 scan lines

	;stuff goes here...

	lda screen_y
	ldy #-1
	sec
.divby6:
		iny
		sbc #6
		bcs .divby6

	ldx #11
.setpfloop:
	lda pf_table,x
	sta pf0ptr,x
	dex
	tya
	adc pf_table,x
	sta pf0ptr,x
	dex
	bpl .setpfloop

	ldx screen_y
	inx
	cpx #192
	bcc .low
		ldx #0
.low:
	stx screen_y

.wait:
	lda INTIM
	bne .wait


	lda #-6
	sta sprite_list_section+0
	lda #-2
	sta sprite_list_section+1
	lda #-5
	sta sprite_list_section+2
	lda #-8
	sta sprite_list_section+3
	lda #0
	sta trash_byte

	brk
	.byte 4

	;cycle 10
	sty VBLANK				;3
	ldy #192/6-1			;2
	sty section_counter		;3
	lda #128				;2
	sta HMP0				;3
	lda #0					;2
	sta sprite_list_index	;3
	tsx						;2
	stx stack_save			;3

	SLEEP 20				;= 53
	sta RESP0				;3 = 56

	SLEEP 17				;= 73

	;******************************
	;* visible screen - 192 lines *
	;******************************
	jmp kernel

	;***********************
	;* overscan - 30 lines *
	;***********************
overscan:
	lda #2
	sta VBLANK

	ldx stack_save
	txs

	brk
	.byte 29

	jmp frame_start








	;---- wsync for multiple lines ----
	;call by brk / .byte number_of_lines
	;returns with y=0
waste_lines: subroutine
	plp
	tsx
	inx
	dec 0,x
	lda (0,x)
	tay

.loop:
	sta WSYNC
	dey
	bne .loop
	rts




	rend



	org $0fec
	include "startup.asm"



	;**********
	;* BANK 1 *
	;**********
	org $1000

	rorg $f000
	include "bs_kernel.asm"
	align 256
	include "foo.asm"
	rend

	org $1fec
	include "startup.asm"




	end